com.smartgwt.client.widgets.menu

## Class MenuButton

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.StatefulCanvas
          - - com.smartgwt.client.widgets.Button
            - - com.smartgwt.client.widgets.menu.MenuButton

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClearHandlers, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasIconClickHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasRuleContextChangedHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasTitleHoverHandlers, HasVisibilityChangedHandlers
  Direct Known Subclasses:
    TreeMenuButton

      public class MenuButton
      extends Button

  Simple subclass of button associated with a menu widget (gets shown below the button).

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MenuButton()`
    `MenuButton(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `MenuButton(java.lang.String title)`
    `MenuButton(java.lang.String title, Menu menu)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.Boolean` | `getAutoDestroyMenu()` If this menuButton is `destroyed`, should it also destroy its `menu`?
    `java.lang.String` | `getEditProxyConstructor()` Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    `java.lang.Boolean` | `getHiliteAccessKey()` If this MenuButton has a specified `accessKey`, underline it in the title of the button by default
    `java.lang.String` | `getIcon()` This property corresponds to the inherited `Button.icon` property, which is used to display the menuButtonImage, so anything you attempt to set there would be clobbered by the internal usage.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `Menu` | `getMenu()` The menu to show.
    `Alignment` | `getMenuAlign()` The horizontal alignment of this button's menu, in relation to the button.
    `java.lang.String` | `getMenuAnimationEffect()` Allows you to specify an animation effect to apply to the menu when it is being shown.
    `java.lang.String` | `getMenuButtonImage()` Image for menu button indicating that the button expands a menu.
    `java.lang.String` | `getMenuButtonImageUp()` Image for menu button indicating that the button expands a menu.
    `static MenuButton` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `int` | `getRollOverMenuHideDelay()` When `showMenuOnRollOver` is true, this is the delay in milliseconds before the menu is automatically hidden following mouseOut.
    `java.lang.Boolean` | `getShowMenuBelow()` The menu drops down below the menu button.
    `java.lang.Boolean` | `getShowMenuButtonImage()` Show menu button image (up / down arrowhead) for this menu button.
    `java.lang.Boolean` | `getShowMenuOnRollOver()` Should the menu be shown automatically when the mouse moves over the button?
    `java.lang.String` | `getTitle()` Default title for the button.
    `void` | `setAutoDestroyMenu(java.lang.Boolean autoDestroyMenu)` If this menuButton is `destroyed`, should it also destroy its `menu`?
    `static void` | `setDefaultProperties(MenuButton menuButtonProperties)` Class level method to set the default properties of this class.
    `void` | `setEditProxyConstructor(java.lang.String editProxyConstructor)` Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
    `void` | `setHiliteAccessKey(java.lang.Boolean hiliteAccessKey)` If this MenuButton has a specified `accessKey`, underline it in the title of the button by default
    `void` | `setIcon(java.lang.String icon)` This property corresponds to the inherited `Button.icon` property, which is used to display the menuButtonImage, so anything you attempt to set there would be clobbered by the internal usage.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.menu.MenuButtonLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `void` | `setMenu(Menu menu)` The menu to show.
    `void` | `setMenuAlign(Alignment menuAlign)` The horizontal alignment of this button's menu, in relation to the button.
    `void` | `setMenuAnimationEffect(java.lang.String menuAnimationEffect)` Allows you to specify an animation effect to apply to the menu when it is being shown.
    `void` | `setMenuButtonImage(java.lang.String menuButtonImage)` Image for menu button indicating that the button expands a menu.
    `void` | `setMenuButtonImageUp(java.lang.String menuButtonImageUp)` Image for menu button indicating that the button expands a menu.
    `void` | `setRollOverMenuHideDelay(int rollOverMenuHideDelay)` When `showMenuOnRollOver` is true, this is the delay in milliseconds before the menu is automatically hidden following mouseOut.
    `void` | `setShowMenuBelow(java.lang.Boolean showMenuBelow)` The menu drops down below the menu button.
    `void` | `setShowMenuButtonImage(java.lang.Boolean showMenuButtonImage)` Show menu button image (up / down arrowhead) for this menu button.
    `void` | `setShowMenuOnRollOver(java.lang.Boolean showMenuOnRollOver)` Should the menu be shown automatically when the mouse moves over the button?
    `void` | `setTitle(java.lang.String title)` Default title for the button.
    `void` | `showMenu()` Programmaticly forces this MenuButton to show it's menu.

    - ### Methods inherited from class com.smartgwt.client.widgets.Button

      `action, addIconClickHandler, addTitleHoverHandler, addToRadioGroup, assertIsButton, deselect, getActionType, getAlign, getAutoFit, getBaseStyle, getCanAdaptWidth, getDisabledIconCursor, getIconAlign, getIconCursor, getIconHeight, getIconOnlyBaseStyle, getIconOrientation, getIconSize, getIconSpacing, getIconStyle, getIconWidth, getOverflow, getRadioGroup, getShowClippedTitleOnHover, getShowDisabled, getShowDisabledIcon, getShowDown, getShowDownIcon, getShowFocused, getShowFocusedIcon, getShowRollOver, getShowRollOverIcon, getShowSelectedIcon, getState, getValign, getWrap, removeFromRadioGroup, removeFromRadioGroup, select, setActionType, setAlign, setAutoFit, setBaseStyle, setCanAdaptWidth, setDefaultProperties, setDisabledIconCursor, setIconAlign, setIconCursor, setIconHeight, setIconOnlyBaseStyle, setIconOrientation, setIconSize, setIconSpacing, setIconStyle, setIconWidth, setLogicalStructure, setOverflow, setRadioGroup, setShowClippedTitleOnHover, setShowDisabled, setShowDisabledIcon, setShowDown, setShowDownIcon, setShowFocused, setShowFocusedIcon, setShowRollOver, setShowRollOverIcon, setShowSelectedIcon, setState, setTitleHoverFormatter, setValign, setWrap, titleClipped, titleHoverHTML`

    - ### Methods inherited from class com.smartgwt.client.widgets.StatefulCanvas

      `getIgnoreRTL, getLabelHPad, getLabelVPad, getOverCanvas, getOverCanvasConstructor, getRedrawOnStateChange, getSelected, getShowFocusedAsOver, getShowOverCanvas, getShowRTLIcon, getStateSuffix, isSelected, setDefaultProperties, setIgnoreRTL, setLabelHPad, setLabelVPad, setLogicalStructure, setOverCanvasConstructor, setRedrawOnStateChange, setSelected, setShowFocusedAsOver, setShowOverCanvas, setShowRTLIcon, setTitleFormatter, setTitleStyle`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoMaskComponents, getAutoParent, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getChildTabPosition, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCorrectZoomOverflow, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getTabIndex, getTestInstance, getTooltip, getTop, getTopAsString, getTopElement, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDragMask, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, onInit, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, removeChild, removeChild, removePeer, removePeer, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeFonts, resizeFonts, resizeFonts, resizeIcons, resizeTo, resizeTo, revealChild, revealChild, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCorrectZoomOverflow, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setTabIndex, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDragMask, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, applyFactoryProperties, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### MenuButton

          public MenuButton()

    - #### MenuButton

          public MenuButton(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### MenuButton

          public MenuButton(java.lang.String title)

    - #### MenuButton

          public MenuButton(java.lang.String title,
                            Menu menu)

  - ### Method Detail

    - #### getOrCreateRef

          public static MenuButton getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `Button`

    - #### setAutoDestroyMenu

          public void setAutoDestroyMenu(java.lang.Boolean autoDestroyMenu)

      If this menuButton is `destroyed`, should it also destroy its `menu`?
      Parameters:
        `autoDestroyMenu` - New autoDestroyMenu value. Default value is true

    - #### getAutoDestroyMenu

          public java.lang.Boolean getAutoDestroyMenu()

      If this menuButton is `destroyed`, should it also destroy its `menu`?
      Returns:
        Current autoDestroyMenu value. Default value is true

    - #### setEditProxyConstructor

          public void setEditProxyConstructor(java.lang.String editProxyConstructor)
                                       throws java.lang.IllegalStateException

      Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
      Overrides:
        `setEditProxyConstructor` in class `StatefulCanvas`
      Parameters:
        `editProxyConstructor` - New editProxyConstructor value. Default value is "MenuEditEditProxy"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `SCClassName`

    - #### getEditProxyConstructor

          public java.lang.String getEditProxyConstructor()

      Default class used to construct the `EditProxy` for this component when the component is `first placed into edit mode`.
      Overrides:
        `getEditProxyConstructor` in class `StatefulCanvas`
      Returns:
        Current editProxyConstructor value. Default value is "MenuEditEditProxy"
      See Also:
        `SCClassName`

    - #### setHiliteAccessKey

          public void setHiliteAccessKey(java.lang.Boolean hiliteAccessKey)
                                  throws java.lang.IllegalStateException

      If this MenuButton has a specified `accessKey`, underline it in the title of the button by default
      Overrides:
        `setHiliteAccessKey` in class `Button`
      Parameters:
        `hiliteAccessKey` - New hiliteAccessKey value. Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getHiliteAccessKey

          public java.lang.Boolean getHiliteAccessKey()

      If this MenuButton has a specified `accessKey`, underline it in the title of the button by default
      Overrides:
        `getHiliteAccessKey` in class `Button`
      Returns:
        Current hiliteAccessKey value. Default value is true

    - #### setIcon

          public void setIcon(java.lang.String icon)

      This property corresponds to the inherited `Button.icon` property, which is used to display the menuButtonImage, so anything you attempt to set there would be clobbered by the internal usage.

      You could add an icon via the `title` property, by using `Canvas.imgHTML()` to generate an appropriate <img> tag and pre-pending it to your title.

      Overrides:
        `setIcon` in class `Button`
      Parameters:
        `icon` - New icon value. Default value is null
      See Also:
        `SCImgURL`, `ButtonIcon overview and related methods`, Icons Example

    - #### getIcon

          public java.lang.String getIcon()

      This property corresponds to the inherited `Button.icon` property, which is used to display the menuButtonImage, so anything you attempt to set there would be clobbered by the internal usage.

      You could add an icon via the `title` property, by using `Canvas.imgHTML()` to generate an appropriate <img> tag and pre-pending it to your title.

      Overrides:
        `getIcon` in class `Button`
      Returns:
        Current icon value. Default value is null
      See Also:
        `SCImgURL`, `ButtonIcon overview and related methods`, Icons Example

    - #### setMenu

          public void setMenu(Menu menu)

      The menu to show.

      For a menu button with no menu (menu: null) the up/down arrow image can be suppressed by setting `showMenuButtonImage`: `false`.

      Parameters:
        `menu` - New menu value. Default value is null

    - #### getMenu

          public Menu getMenu()

      The menu to show.

      For a menu button with no menu (menu: null) the up/down arrow image can be suppressed by setting `showMenuButtonImage`: `false`.

      Returns:
        Current menu value. Default value is null

    - #### setMenuAlign

          public void setMenuAlign(Alignment menuAlign)
                            throws java.lang.IllegalStateException

      The horizontal alignment of this button's menu, in relation to the button. When unset, default behavior is to align the right edges of button and menu if the page is in RTL mode, and the left edges otherwise.
      Parameters:
        `menuAlign` - New menuAlign value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMenuAlign

          public Alignment getMenuAlign()

      The horizontal alignment of this button's menu, in relation to the button. When unset, default behavior is to align the right edges of button and menu if the page is in RTL mode, and the left edges otherwise.
      Returns:
        Current menuAlign value. Default value is null

    - #### setMenuAnimationEffect

          public void setMenuAnimationEffect(java.lang.String menuAnimationEffect)

      Allows you to specify an animation effect to apply to the menu when it is being shown. Valid options are "none" (no animation), "fade", "slide" and "wipe". If unspecified falls through to `menu.showAnimationEffect`

      Note : This is an advanced setting

      Parameters:
        `menuAnimationEffect` - New menuAnimationEffect value. Default value is null

    - #### getMenuAnimationEffect

          public java.lang.String getMenuAnimationEffect()

      Allows you to specify an animation effect to apply to the menu when it is being shown. Valid options are "none" (no animation), "fade", "slide" and "wipe". If unspecified falls through to `menu.showAnimationEffect`
      Returns:
        Current menuAnimationEffect value. Default value is null

    - #### setMenuButtonImage

          public void setMenuButtonImage(java.lang.String menuButtonImage)
                                  throws java.lang.IllegalStateException

      Image for menu button indicating that the button expands a menu. This image is shown for menus expanding down from the button. Menu direction is controlled by `showMenuBelow`.

      Note : This is an advanced setting

      Parameters:
        `menuButtonImage` - New menuButtonImage value. Default value is "[SKIN]menu_button.gif"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setMenuButtonImageUp(java.lang.String)`, `SCImgURL`

    - #### getMenuButtonImage

          public java.lang.String getMenuButtonImage()

      Image for menu button indicating that the button expands a menu. This image is shown for menus expanding down from the button. Menu direction is controlled by `showMenuBelow`.
      Returns:
        Current menuButtonImage value. Default value is "[SKIN]menu_button.gif"
      See Also:
        `getMenuButtonImageUp()`, `SCImgURL`

    - #### setMenuButtonImageUp

          public void setMenuButtonImageUp(java.lang.String menuButtonImageUp)
                                    throws java.lang.IllegalStateException

      Image for menu button indicating that the button expands a menu. This image is shown for menus expanding up from the button. Menu direction is controlled by `showMenuBelow`.

      Note : This is an advanced setting

      Parameters:
        `menuButtonImageUp` - New menuButtonImageUp value. Default value is "[SKIN]menu_button_up.gif"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `setMenuButtonImage(java.lang.String)`, `SCImgURL`

    - #### getMenuButtonImageUp

          public java.lang.String getMenuButtonImageUp()

      Image for menu button indicating that the button expands a menu. This image is shown for menus expanding up from the button. Menu direction is controlled by `showMenuBelow`.
      Returns:
        Current menuButtonImageUp value. Default value is "[SKIN]menu_button_up.gif"
      See Also:
        `getMenuButtonImage()`, `SCImgURL`

    - #### setRollOverMenuHideDelay

          public void setRollOverMenuHideDelay(int rollOverMenuHideDelay)
                                        throws java.lang.IllegalStateException

      When `showMenuOnRollOver` is true, this is the delay in milliseconds before the menu is automatically hidden following mouseOut.

      Note : This is an advanced setting

      Parameters:
        `rollOverMenuHideDelay` - New rollOverMenuHideDelay value. Default value is 250
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getRollOverMenuHideDelay

          public int getRollOverMenuHideDelay()

      When `showMenuOnRollOver` is true, this is the delay in milliseconds before the menu is automatically hidden following mouseOut.
      Returns:
        Current rollOverMenuHideDelay value. Default value is 250
      See Also:
        `Appearance overview and related methods`

    - #### setShowMenuBelow

          public void setShowMenuBelow(java.lang.Boolean showMenuBelow)

      The menu drops down below the menu button. Set to false if the menu should appear above the menu button.
      If this method is called after the component has been drawn/initialized: Setter for the 'showMenuButtonBelow' property - determines whether the menu will be shown above or below the menubutton.
      Parameters:
        `showMenuBelow` - True if the menu should be shown below the menubutton. Default value is true

    - #### getShowMenuBelow

          public java.lang.Boolean getShowMenuBelow()

      The menu drops down below the menu button. Set to false if the menu should appear above the menu button.
      Returns:
        Current showMenuBelow value. Default value is true

    - #### setShowMenuButtonImage

          public void setShowMenuButtonImage(java.lang.Boolean showMenuButtonImage)
                                      throws java.lang.IllegalStateException

      Show menu button image (up / down arrowhead) for this menu button.
      If this method is called after the component has been drawn/initialized: Setter for the 'showMenuButtonImage' property - shows/hides the menu button image at runtime.
      Parameters:
        `showMenuButtonImage` - Should the image be shown. Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getShowMenuButtonImage

          public java.lang.Boolean getShowMenuButtonImage()

      Show menu button image (up / down arrowhead) for this menu button.
      Returns:
        Current showMenuButtonImage value. Default value is true

    - #### setShowMenuOnRollOver

          public void setShowMenuOnRollOver(java.lang.Boolean showMenuOnRollOver)
                                     throws java.lang.IllegalStateException

      Should the menu be shown automatically when the mouse moves over the button?

      When enabled, menus used with this `MenuButton` should not be used with any other component.

      Note : This is an advanced setting

      Parameters:
        `showMenuOnRollOver` - New showMenuOnRollOver value. Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getShowMenuOnRollOver

          public java.lang.Boolean getShowMenuOnRollOver()

      Should the menu be shown automatically when the mouse moves over the button?

      When enabled, menus used with this `MenuButton` should not be used with any other component.

      Returns:
        Current showMenuOnRollOver value. Default value is false
      See Also:
        `Appearance overview and related methods`

    - #### setTitle

          public void setTitle(java.lang.String title)

      Default title for the button.
      Overrides:
        `setTitle` in class `Button`
      Parameters:
        `title` - New title value. Default value is "Show Menu"
      See Also:
        `HTMLString`, `Basics overview and related methods`, States Example

    - #### getTitle

          public java.lang.String getTitle()

      Default title for the button.
      Overrides:
        `getTitle` in class `Button`
      Returns:
        Current title value. Default value is "Show Menu"
      See Also:
        `HTMLString`, `Basics overview and related methods`, States Example

    - #### showMenu

          public void showMenu()

      Programmaticly forces this MenuButton to show it's menu.

    - #### setDefaultProperties

          public static void setDefaultProperties(MenuButton menuButtonProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `menuButtonProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.menu.MenuButtonLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `Button`